package org.netbeans.modules.cnd.dwarfdump.dwarf;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

public class DwarfExpression {
	private List<DwarfExpressionOperation> operations = new ArrayList<DwarfExpressionOperation>();
	
	public DwarfExpression() {
		// Do nothing
	}
	
	public void addOperation(DwarfExpressionOperation operation) {
		operations.add(operation);
	}
	
	public List<DwarfExpressionOperation> getOperations() {
		return operations;
	}
	
    public void dump(PrintStream out) {
    	boolean needSpace = false;
    	for (DwarfExpressionOperation operation : operations) {
    		if (needSpace) {
        		out.print(' ');
    		}
    		operation.dump(out);
    		needSpace = true;
    	}
    }

	public int numOperations() {
		return operations.size();
	}

	public DwarfExpressionOperation getOperation(int i) {
		return operations.get(i);
	}
}
