package org.netbeans.modules.cnd.dwarfdump.section;

/**
 * A row of the debug line matrix
 * @author Richard Osborne
 *
 */
public class DebugLineRow implements Cloneable, Comparable<Object>  {
	public long address;
	public long file;
	public long line;
	public long column;
	public boolean is_stmt;
	public boolean basic_block;
	public boolean end_sequence;
	public boolean prologue_end;
	public boolean epilogue_begin;
	public long isa;
	
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			// this shouldn't happen, since we are Cloneable
			throw new RuntimeException(e);
		}
	}

	public int compareTo(Object o) {
		DebugLineRow r = (DebugLineRow)o;
		if (address == r.address) {
			
			if (line == r.line) {
				// When a sequence ends on an address it is actually an 
				// address after the end of sequence
				if (end_sequence)
					return -1;
				else
					return 1;
			} else if (line > r.line) {
				return 1;
			} else {
				return -1;
			}
		} else if (address > r.address) {
			return 1;
		} else {
			return -1;
		}
	}
}
